<?php
/**
 * Functions used by users.
 * @author Flipper Code <hello@flippercode.com>
 * @version 1.0.4
 * @package Was_This_Helpful
 */

function wthp_already_voted( $post_id ) {

	global $wpdb, $blog_id;

	$db = maybe_unserialize( get_option( 'wthp_option_settings' ) );
	if(!array_key_exists('wthp_option_settings',$db)) 
	$db['wthp_option_settings'] = $db;

	$wthp_option['wthp_option_settings'] = $db['wthp_option_settings'];
	if ( 'limit' == $wthp_option['wthp_option_settings']['feedback_limit'] )
	return false;
	
	$tbl = $wpdb->base_prefix.'wthp_helpful_log';
	$base_query = "SELECT post_id FROM {$tbl} WHERE post_id = $post_id AND blog_id = $blog_id";

	if ( ($user_id = get_current_user_id()) > 0 ) {
		return $wpdb->get_var( "$base_query AND user_id= $user_id" );
	}

	$ip = get_client_ip();
	return $wpdb->get_var( "$base_query AND ip_address = '$ip' " );

}

function get_client_ip() {

	$ipaddress = '';

	if ( $_SERVER['HTTP_CLIENT_IP'] ) {
		$ipaddress = $_SERVER['HTTP_CLIENT_IP']; } else if ( $_SERVER['HTTP_X_FORWARDED_FOR'] ) {
		$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR']; } else if ( $_SERVER['HTTP_X_FORWARDED'] ) {
			$ipaddress = $_SERVER['HTTP_X_FORWARDED']; } else if ( $_SERVER['HTTP_FORWARDED_FOR'] ) {
			$ipaddress = $_SERVER['HTTP_FORWARDED_FOR']; } else if ( $_SERVER['HTTP_FORWARDED'] ) {
				$ipaddress = $_SERVER['HTTP_FORWARDED']; } else if ( $_SERVER['REMOTE_ADDR'] ) {
				$ipaddress = $_SERVER['REMOTE_ADDR'];
				} else { 			 $ipaddress = 'UNKNOWN'; }

				return $ipaddress;
}
function wthp_get_transient_key($post_id) {

	$user_id = get_current_user_id();

	$ip = get_client_ip();

	return 'user_'.$user_id.'_ip_'.$ip.'_post_'.$post_id;

}
