<?php
if ( ! class_exists( 'WTH_FORM' ) ) {

	class WTH_FORM extends FlipperCode_HTML_Markup{
		
		function __construct($options = array()) {

            $premium_features = "<ul class='fc-pro-features'>
			<li>Ask Positive or Negative feedback explanation from visitors.</li>
			<li>Get beautiful feedback themes.</li>
			<li>View Positive & Negative reviews for each post easily to improve your blog post.</li>
			<li>View overall feedbacks using pie chart.</li>
			<li>Download CSV or All positive & negative reviews to analysis your blog posts.</li>
			<li>Apply readymade interactive templates or apply your own design using placeholder.</li>
			<li>Change question & labels in the backend setting.</li>
			<li>Quick overview of each post performance in the admin bar.</li>
			<li>Share post via facebook & twitter on Positive response.</li>
			<li>Ask feedback details on Positive & Negative Reviews. You can make it mandatory in the backend.</li>
			<li>Exclude feedback option for certain posts or categories easily.</li>
			<li>Reset reviews to zero before make them live using ‘Reset Reviews’ option. You can reset review for individual posts as well.</li>
			<li>Download reporting by time period or custom dates.</li>
			<li>Allow feedback by logged in users only.</li>
			<li>Use {yes_count}, {no_count}, {yes_percentage}, {no_percentage}, {total_count} placeholders to modify your custom template.</li>
			<li>Limit Feedback by IP Address. You can allow unlimited feedback from an IP using backend.</li>
			<li>Enable Google Analytics to view feedbacks events in your google analytics account.</li>
			<li>Download  feedback reporting on last N Days.</li>
			</ul>";

			$productInfo = array('productName' => __('Was This Helpful',WTH_TEXT_DOMAIN),
                        'productSlug' => 'was-this-helpful',
                        'productTagLine' => 'Get reviews about posts/pages from visitors to make your blog more valuable for readers.',
                        'productTextDomain' => WTH_TEXT_DOMAIN,
                        'productIconImage' => WTH_URL.'core/core-assets/images/wp-poet.png',
                        'videoURL' => 'https://www.youtube.com/playlist?list=PLlCp-8jiD3p3zDke_Clvw0EtWzvqXt0Oz',
                        'productVersion' => WTH_VERSION,
                        'docURL' => 'http://guide.flippercode.com/postsreview/',
                        'demoURL' => 'https://www.flippercode.com/product/was-this-helpful-pro/',
                        'productImagePath' => WTH_URL.'core/core-assets/product-images/',
                        'productSaleURL' => 'https://codecanyon.net/item/wordpress-store-locator/15672329',
                        'multisiteLicence' => 'http://codecanyon.net/item/wordpress-store-locator/15672329?license=extended&open_purchase_for_item_id=15672329&purchasable=source',
                        'premium_features' => $premium_features,
			);

			$productInfo = array_merge($productInfo, $options);
			parent::__construct($productInfo);

		}

	}

}
