<?php
/**
 * Posts Pro Overviews.
 * @package Posts
 * @author Flipper Code <flippercode>
 **/
 $form  = new WTH_FORM();
 echo $form->show_header();
?>

<div class="flippercode-ui">
  <div class="fc-main">
<div class="fc-container">
  <div class="fc-divider">
      <div class="fc-back fc-how">
<div class="row flippercode-main wth-docs">
    <div class="fc-12">
           <h4 class="fc-title-blue"> <?php _e( 'How to Show Feedback Option Automatically',WTH_TEXT_DOMAIN ); ?> </h4>
          <div class="wpgmp-overview">
            You can display feedback option on all posts, pages or custom posts type using backend settings.
            <ul>
              <li><b>Choose Posts Types</b>: First you need to decide on which posts types you want to apply 'Was This Helpful' Feedback Option. Go to 'Settings' page and choose posts types.</li>
              <li><b>Choose Template </b>: Then you need to decide templates where you want to show feedback option. To display feedback option on each post page, go to 'Settings' page and tick 'For Single Post'. To display feedback option on Archieves Page or Categories Page, you can choose 'For Blog archives' and 'For Categories
' option. </li>
            </ul>

          </div>

          <h4 class="fc-title-blue"> <?php _e( 'How to Show Feedback Option Manually',WTH_TEXT_DOMAIN ); ?> </h4>
          <div class="wpgmp-overview">
            You can display feedback option on selected posts as well.
            <ul>
              <li>Copy <b>[was-this-helpful]</b> shortcode and paste it on the post where you want to display feedback option.</li>
            </ul>
          </div>

          <h4 class="fc-title-blue"> <?php _e( 'How to Change Text',WTH_TEXT_DOMAIN ); ?> </h4>
          <div class="wpgmp-overview">
          You can change question, labels and confirmation message easily.
          <ul>
              <li>Go to 'Text Settings' section on 'Settings' page and you can change question, positive button label, negative button label and thank you message.</li>
          </ul>

          </div>

          <h4 class="fc-title-blue"> <?php _e( 'How to Reset Ratings',WTH_TEXT_DOMAIN ); ?> </h4>
          <div class="wpgmp-overview">
          You can reset all ratings to zero when you make your site live.
          <ul>
              <li>Go to 'Settings' page and tick on 'Reset Reviews' and click on 'Save Settings'. All positive or negative ratings will be removed.</li>
          </ul>

          </div>

          <h4 class="fc-title-blue"> <?php _e( 'Advanced Options',WTH_TEXT_DOMAIN ); ?> </h4>
          <div class="wpgmp-overview">
          You can allow feedback from logged in users only and limit by IP easily.
          <ul>
              <li><b>Login Required</b> - Go to 'Settings' page and tick on 'Login Required?' and It'll ask to get logged in if user is not logged in. You can change login message also.</li>
              <li><b>Limit By IP</b> - Go to 'Settings' page and choose 'By IP' to get only one review per IP on the post. You can choose 'No Limit' to allow any number of reviews.</li>
          </ul>
          </div>
          <a style="text-decoration:none;" target="_blank" href="http://codecanyon.net/item/was-this-helpful/7415852">
          <h4 class="fc-title-blue"> <?php _e( 'Additionl Features Present In Pro Version',WPGMP_TEXT_DOMAIN ); ?> </h4>
          </a>
          <div class="wpgmp-overview">
           
<ol>
<li> Ask Positive or Negative feedback explanation from visitors.
<li> Get beautiful feedback themes.
<li> View Positive & Negative reviews for each post easily to improve your blog post.
<li> Enable/Disable review option for each post or post types.
<li> View overall feedbacks using pie chart.
<li> Download CSV or All positive & negative reviews to analysis your blog posts.
<li> Apply readymade interactive templates or apply your own design using placeholder.
<li> Change question & labels in the backend setting.
<li> Quick overview of each post performance in the admin bar.
<li> Share post via facebook & twitter on Positive response.
<li> Ask feedback details on Positive & Negative Reviews. You can make it mandatory in the backend.
<li> Exclude feedback option for certain posts or categories easily.
<li> Reset reviews to zero before make them live using ‘Reset Reviews’ option. You can reset review for individual posts as well.
<li> Download reporting by time period or custom dates.
<li> Allow feedback by logged in users only.
<li> Use {yes_count}, {no_count}, {yes_percentage}, {no_percentage}, {total_count} placeholders to modify your custom template.
<li> Limit Feedback by IP Address. You can allow unlimited feedback from an IP using backend.
<li> Enable Google Analytics to view feedbacks events in your google analytics account.
<li> Download  feedback reporting on last N Days.
<li> <a target="_blank" href="http://codecanyon.net/item/was-this-helpful/7415852">Download [Was This Helpful Version](http://codecanyon.net/item/was-this-helpful/7415852)</a>
</ol>

</div>
</div>
</div>
</div>
</div>
</div>
</div>

